## remmina 1.2.0-rcgit.27+dfsg

=== debian/changelog ===
remmina (1.2.0-rcgit.27+dfsg-3) unstable; urgency=medium

  * debian/: EXEC plugin added
  * debian/control:
    - update Maintainer e-address
    - drop Jörg from Uploaders
    - add remmina-plugin-exec to Suggests
  * debian/patches/: patchset updated
    - 0003-Fix_clipboard_cleanup.patch added
    - 0004-Switch_stats_URL_to_https.patch added

 -- Matteo F. Vescovi <mfv@debian.org>  Wed, 21 Feb 2018 16:11:52 +0100

remmina (1.2.0-rcgit.27+dfsg-2) unstable; urgency=medium

  * debian/control: update Recommends and add Suggests fields
    (Closes: #890351)

 -- Matteo F. Vescovi <mfv@debian.org>  Tue, 20 Feb 2018 00:00:51 +0100

remmina (1.2.0-rcgit.27+dfsg-1) unstable; urgency=medium

  * New upstream release
  * debian/patches/: patchset updated
    - 0001-Fix_RDP_GFX_RFX_mode.patch added
    - 0002-Add_StartupWMClass_to_.desktop.in_file.patch added
    Thanks to Giovanni Panozzo (upstream dev) for them.
  * debian/rules: drop obsolete override entry
  * debian/watch: version and options updated
  * debian/: debhelper bump 10 -> 11
  * debian/control: S-V bump 4.1.2 -> 4.1.3 (no changes needed)
  * debian/control: Vcs-* fields updated pointing to salsa
  * debian/copyright: http:// -> https:// for copyright format
  * debian/control: new build-dependencies added
    - libjson-glib-dev and libsoup2.4-dev

 -- Matteo F. Vescovi <mfv@debian.org>  Mon, 19 Feb 2018 22:56:23 +0100

remmina (1.2.0-rcgit.26+dfsg-1) unstable; urgency=medium

  * New upstream release
    (+dfsg due to dropping useless stuff for Debian packaging)
    - debian/: 'gnome' plugin moved to 'secret'
  * debian/: repacking tools added
  * debian/watch: mangling options added due to repacking
  * debian/control: S-V bump 4.1.1 -> 4.1.2 (no changes needed)

 -- Matteo F. Vescovi <mfv@debian.org>  Sat, 30 Dec 2017 15:55:39 +0100

remmina (1.2.0-rcgit.24-3) unstable; urgency=medium

  * debian/control:
    - descriptions updated
    - Section updated to 'x11'

 -- Matteo F. Vescovi <mfv@debian.org>  Sun, 05 Nov 2017 13:29:33 +0100

remmina (1.2.0-rcgit.24-2) unstable; urgency=medium

  * debian/control: appindicator b-deps switched around

 -- Matteo F. Vescovi <mfv@debian.org>  Mon, 30 Oct 2017 12:21:44 +0100

remmina (1.2.0-rcgit.24-1) unstable; urgency=medium

  * New upstream release
    - debian/control:
      - drop useless webkit2gtk b-deps
      - drop obsolete libspice-client-gtk-2.0-dev b-dep
      - split to multiple appindicator b-deps

 -- Matteo F. Vescovi <mfv@debian.org>  Fri, 27 Oct 2017 20:28:27 +0200

remmina (1.2.0-rcgit.23-1) unstable; urgency=medium

  * New upstream release

 -- Matteo F. Vescovi <mfv@debian.org>  Tue, 24 Oct 2017 23:07:19 +0200

remmina (1.2.0-rcgit.21-1) unstable; urgency=medium

  * New upstream release (Closes: #777638)
    - debian/patches/: patchset dropped (applied upstream)
    - debian/: fix installation paths

 -- Matteo F. Vescovi <mfv@debian.org>  Mon, 09 Oct 2017 22:06:21 +0200

remmina (1.2.0-rcgit.20-5) unstable; urgency=medium

  * debian/: new remmina-dev binary package added
  * debian/copyright:
    - add myself for debian/
    - upstream info updated
  * debian/control: S-V bump 4.1.0 -> 4.1.1 (no changes needed)

 -- Matteo F. Vescovi <mfv@debian.org>  Mon, 02 Oct 2017 21:57:07 +0200

remmina (1.2.0-rcgit.20-4) unstable; urgency=medium

  * Upload to unstable
  * debian/control: S-V bump 4.0.0 -> 4.1.0 (no changes needed)

 -- Matteo F. Vescovi <mfv@debian.org>  Mon, 25 Sep 2017 14:29:44 +0200

remmina (1.2.0-rcgit.20-3) experimental; urgency=medium

  * debian/control: add Multi-Arch support
  * debian/rules: drop override on dh_auto_configure
    (enabling applicator support)

 -- Matteo F. Vescovi <mfv@debian.org>  Wed, 20 Sep 2017 22:59:22 +0200

remmina (1.2.0-rcgit.20-2) experimental; urgency=medium

  * debian/control:
    - NX plugin re-enabled
    - drop libfreerdp-plugins-standard as Recommends
      for RDP plugin
  * debian/: Spice plugin added

 -- Matteo F. Vescovi <mfv@debian.org>  Fri, 15 Sep 2017 15:42:28 +0200

remmina (1.2.0-rcgit.20-1) experimental; urgency=medium

  * New upstream release (Closes: #874571)
  * debian/control:
    - fix Vcs-Git usage of https://
    - re-enable libssh and drop libssl b-deps
    - S-V bump 3.9.8 -> 4.0.0 (no changes needed)
  * debian/rules:
    - remove duplicate manpage from remmina-common package

 -- Matteo F. Vescovi <mfv@debian.org>  Wed, 13 Sep 2017 22:15:06 +0200

remmina (1.2.0-rcgit.17-1) experimental; urgency=medium

  * New upstream release.
  * debian/copyright:
    - Update copyright years for 2017.
    - Refresh authors.
  * debian/control:
    - Rewrite and refresh Buld-Depends.
    - Because of incompatibility during the libssl transition:
      + Comment out libssh-dev.
      + Comment out binary remmina-plugin-nx.
  * debian/rules:
    - Add -DWITH_LIBSSH=OFF to dh_auto_configure.
  * debian/docs:
    - Rename README to README.md.
  * debian/patches:
    - Refresh 0700-desktop.patch.
    - Disable unused patches.

 -- Jörg Frings-Fürst <debian@jff-webhosting.net>  Sun, 22 Jan 2017 17:36:16 +0100

=== debian/control ===
Source: remmina
Section: x11
Priority: optional
Maintainer: Debian Remote Maintainers <debian-remote@lists.debian.org>
Uploaders:
 Matteo F. Vescovi <mfv@debian.org>
Build-Depends:
 cmake (>= 3.5),
 debhelper (>= 11~),
 freerdp2-dev (>= 2.0.0~),
 libayatana-appindicator3-dev | libappindicator3-dev,
 libavahi-ui-gtk3-dev (>= 0.6.0),
 libgcrypt-dev | libgcrypt20-dev,
 libgnutls28-dev,
 libgtk-3-dev,
 libjpeg-dev,
 libjson-glib-dev,
 libsecret-1-dev,
 libsoup2.4-dev,
 libspice-client-gtk-3.0-dev,
 libspice-protocol-dev,
 libssh-dev (>= 0.8.0~20170825.94fa1e38),
 libtelepathy-glib-dev,
 libvncserver-dev,
 libvte-2.91-dev,
 libxkbfile-dev
Standards-Version: 4.1.3
Homepage: http://www.remmina.org/
Vcs-Git: https://salsa.debian.org/debian-remote-team/remmina.git
Vcs-Browser: https://salsa.debian.org/debian-remote-team/remmina

Package: remmina
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 remmina-common (= ${source:Version}),
 default-dbus-session-bus | dbus-session-bus
Recommends:
 remmina-plugin-rdp,
 remmina-plugin-vnc,
 remmina-plugin-secret
Suggests:
 remmina-plugin-exec,
 remmina-plugin-nx,
 remmina-plugin-spice,
 remmina-plugin-telepathy,
 remmina-plugin-xdmcp
Description: GTK+ Remote Desktop Client
 Remmina is a remote desktop client written in GTK+, aiming to be
 useful for system administrators and travellers, who need to work
 with lots of remote computers in front of either large monitors or
 tiny netbooks.
 .
 Remmina supports multiple network protocols in an integrated and
 consistent user interface.
 .
 Currently RDP, VNC, SPICE, NX, XDMCP and SSH are supported.

Package: remmina-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: remmina
Description: Common files for Remmina
 Remmina is a remote desktop client written in GTK+, aiming to be
 useful for system administrators and travellers, who need to work
 with lots of remote computers in front of either large monitors or
 tiny netbooks.
 .
 Remmina supports multiple network protocols in an integrated and
 consistent user interface.
 .
 Currently RDP, VNC, SPICE, NX, XDMCP, EXEC and SSH are supported.
 .
 This package contains the common files.

Package: remmina-dev
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 remmina (= ${binary:Version})
Description: Headers for Remmina
 Remmina is a remote desktop client written in GTK+, aiming to be
 useful for system administrators and travellers, who need to work
 with lots of remote computers in front of either large monitors or
 tiny netbooks.
 .
 Remmina supports multiple network protocols in an integrated and
 consistent user interface.
 .
 Currently RDP, VNC, SPICE, NX, XDMCP, EXEC and SSH are supported.
 .
 This package contains the development headers for Remmina, to develop
 new plugins.

Package: remmina-plugin-rdp
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 remmina (= ${binary:Version})
Description: RDP plugin for Remmina
 Remmina is a remote desktop client written in GTK+, aiming to be
 useful for system administrators and travellers, who need to work
 with lots of remote computers in front of either large monitors or
 tiny netbooks.
 .
 Remmina supports multiple network protocols in an integrated and
 consistent user interface.
 .
 Currently RDP, VNC, SPICE, NX, XDMCP, EXEC and SSH are supported.
 .
 This package contains the RDP plugin for Remmina.

Package: remmina-plugin-vnc
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 remmina (= ${binary:Version})
Description: VNC plugin for Remmina
 Remmina is a remote desktop client written in GTK+, aiming to be
 useful for system administrators and travellers, who need to work
 with lots of remote computers in front of either large monitors or
 tiny netbooks.
 .
 Remmina supports multiple network protocols in an integrated and
 consistent user interface.
 .
 Currently RDP, VNC, SPICE, NX, XDMCP, EXEC and SSH are supported.
 .
 This package contains the VNC plugin for Remmina.

Package: remmina-plugin-xdmcp
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 remmina (= ${binary:Version}),
 xserver-xephyr
Description: XDMCP plugin for Remmina
 Remmina is a remote desktop client written in GTK+, aiming to be
 useful for system administrators and travellers, who need to work
 with lots of remote computers in front of either large monitors or
 tiny netbooks.
 .
 Remmina supports multiple network protocols in an integrated and
 consistent user interface.
 .
 Currently RDP, VNC, SPICE, NX, XDMCP, EXEC and SSH are supported.
 .
 This package contains the XDMCP plugin for Remmina.

Package: remmina-plugin-nx
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 remmina (= ${binary:Version}),
 nxproxy
Description: NX plugin for Remmina
 Remmina is a remote desktop client written in GTK+, aiming to be
 useful for system administrators and travellers, who need to work
 with lots of remote computers in front of either large monitors or
 tiny netbooks.
 .
 Remmina supports multiple network protocols in an integrated and
 consistent user interface.
 .
 Currently RDP, VNC, SPICE, NX, XDMCP, EXEC and SSH are supported.
 .
 This package contains the NX plugin for Remmina.

Package: remmina-plugin-spice
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 remmina (= ${binary:Version}),
Description: Spice plugin for Remmina
 Remmina is a remote desktop client written in GTK+, aiming to be
 useful for system administrators and travellers, who need to work
 with lots of remote computers in front of either large monitors or
 tiny netbooks.
 .
 Remmina supports multiple network protocols in an integrated and
 consistent user interface.
 .
 Currently RDP, VNC, SPICE, NX, XDMCP, EXEC and SSH are supported.
 .
 This package contains the Spice plugin for Remmina.

Package: remmina-plugin-telepathy
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 remmina (= ${binary:Version})
Description: Telepathy plugin for Remmina
 Remmina is a remote desktop client written in GTK+, aiming to be
 useful for system administrators and travellers, who need to work
 with lots of remote computers in front of either large monitors or
 tiny netbooks.
 .
 Remmina supports multiple network protocols in an integrated and
 consistent user interface.
 .
 Currently RDP, VNC, SPICE, NX, XDMCP, EXEC and SSH are supported.
 .
 This package contains the Telepathy plugin for Remmina.

Package: remmina-plugin-secret
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 remmina (= ${binary:Version})
Breaks: remmina-plugin-gnome
Replaces: remmina-plugin-gnome
Description: Secret plugin for Remmina
 Remmina is a remote desktop client written in GTK+, aiming to be
 useful for system administrators and travellers, who need to work
 with lots of remote computers in front of either large monitors or
 tiny netbooks.
 .
 Remmina supports multiple network protocols in an integrated and
 consistent user interface.
 .
 Currently RDP, VNC, SPICE, NX, XDMCP, EXEC and SSH are supported.
 .
 This package contains the secret plugin for Remmina, which
 allows one to store and retrieve passwords from GNOME Keyring
 or KWallet.

Package: remmina-plugin-exec
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 remmina (= ${binary:Version})
Description: EXEC plugin for Remmina
 Remmina is a remote desktop client written in GTK+, aiming to be
 useful for system administrators and travellers, who need to work
 with lots of remote computers in front of either large monitors or
 tiny netbooks.
 .
 Remmina supports multiple network protocols in an integrated and
 consistent user interface.
 .
 Currently RDP, VNC, SPICE, NX, XDMCP, EXEC and SSH are supported.
 .
 This package contains the EXEC plugin for Remmina.

=== debian/rules ===
#!/usr/bin/make -f

# hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

LDFLAGS += -Wl,--as-needed

%:
	dh $@

override_dh_install:
	dh_install
	[ -d debian/remmina-common ] && \
		find $(CURDIR)/debian/remmina-common -name "*remmina.desktop" -delete && \
		find $(CURDIR)/debian/remmina-common -name "*remmina.1" -delete && \
		find $(CURDIR)/debian/remmina-common -type d -empty -delete || true

## remmina 1.2.0-rcgit.29+dfsg

=== debian/changelog ===
remmina (1.2.0-rcgit.29+dfsg-1ubuntu1.2) bionic-security; urgency=medium

  * Fix compatibility with FreeRDP 2.1.1 and xrdp. (LP: #1881799)
    - debian/patches/xrdp-compat1.patch: added xrdp friendly options to
      plugins/rdp/rdp_plugin.c.
    - debian/patches/xrdp-compat2.patch: disable glyph cache by default in
      plugins/rdp/rdp_plugin.c.
    - debian/patches/xrdp-compat3.patch: remove unneeded OrderSupport
      struct init in plugins/rdp/rdp_plugin.c.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 03 Jun 2020 09:24:50 -0400

remmina (1.2.0-rcgit.29+dfsg-1ubuntu1.1) bionic-security; urgency=medium

  * Fix compatibility with FreeRDP 2.1.1 security update.
    - debian/patches/rdppaint*.patch: backport upstream patches to fix
      compatibility wither newer FreeRDP versions.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 27 May 2020 08:19:08 -0400

remmina (1.2.0-rcgit.29+dfsg-1ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/patches/translations.patch,
      - Make translatable and add keywords.
    - Switch appindicator dependencies

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 10 Apr 2018 16:21:16 +0200

remmina (1.2.0-rcgit.29+dfsg-1) unstable; urgency=medium

  * New upstream release
    - debian/patches/: patchset dropped (applied upstream)
  * debian/remmina-plugin-telepathy.install: fix installation path
  * debian/control: S-V bump 4.1.3 -> 4.1.4 (no changes needed)

 -- Matteo F. Vescovi <mfv@debian.org>  Mon, 09 Apr 2018 21:36:06 +0200

remmina (1.2.0-rcgit.27+dfsg-4ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/patches/translations.patch,
      - Make translatable and add keywords.
    - Switch appindicator dependencies

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 25 Mar 2018 12:42:17 +0200

remmina (1.2.0-rcgit.27+dfsg-4) unstable; urgency=medium

  * debian/patches/: patchset updated
    - 0005-Fixes_segmentation_fault.patch added
  * debian/repack.local: flatpak/ directory removed

 -- Matteo F. Vescovi <mfv@debian.org>  Sat, 24 Mar 2018 22:11:36 +0100

remmina (1.2.0-rcgit.27+dfsg-3ubuntu1) bionic; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - debian/patches/translations.patch,
      - Make translatable and add keywords.
    - Switch appindicator dependencies
    - debian/patches/translations.patch: 

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 22 Feb 2018 13:17:41 +0100

remmina (1.2.0-rcgit.27+dfsg-2ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/patches/translations.patch,
      - Make translatable and add keywords.
    - Switch appindicator dependencies
    - debian/patches/translations.patch:

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 21 Feb 2018 08:51:10 +0100

remmina (1.2.0-rcgit.27+dfsg-1ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/patches/translations.patch,
      - Make translatable and add keywords.
    - Switch appindicator dependencies
    - debian/patches/translations.patch:

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 20 Feb 2018 11:46:32 +0100

remmina (1.2.0-rcgit.26+dfsg-1ubuntu2) bionic; urgency=low

  * debian/patches/translations.patch:
    - Don't add "X-Ubuntu-Gettext-Domain=remmina" to .desktop file to
      prevent that the file's translations are removed by
      pkgstriptranslations (LP: #1746004).

 -- Gunnar Hjalmarsson <gunnarhj@ubuntu.com>  Mon, 05 Feb 2018 11:15:00 +0100

remmina (1.2.0-rcgit.26+dfsg-1ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/patches/translations.patch,
      - Make translatable and add keywords.
    - Switch appindicator dependencies

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 31 Dec 2017 17:31:11 +0100

remmina (1.2.0-rcgit.24-3ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/patches/translations.patch,
      - Make translatable and add keywords.
    - Switch appindicator dependencies

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 06 Nov 2017 14:55:56 +0100

remmina (1.2.0-rcgit.24-2ubuntu2) bionic; urgency=medium

  * Switch appindicator dependencies, better stick with libappindicator3 for
    now.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 31 Oct 2017 16:14:42 +0100

remmina (1.2.0-rcgit.24-2ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/patches/translations.patch,
      - Make translatable and add keywords.
  * Try to drop the appindicator delta, included in Debian (swapped around)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 31 Oct 2017 15:29:45 +0100

remmina (1.2.0-rcgit.24-1ubuntu2) bionic; urgency=medium

  * Fixup previous upload

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 28 Oct 2017 13:59:22 +0200

remmina (1.2.0-rcgit.24-1ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Build-depend on libappindicator3-dev, intltool to enable
      support
    - debian/patches/translations.patch,
      - Make translatable and add keywords.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 28 Oct 2017 12:12:45 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: remmina
 Section: x11
 Priority: optional
-Maintainer: Debian Remote Maintainers <debian-remote@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Remote Maintainers <debian-remote@lists.debian.org>
 Uploaders:
  Matteo F. Vescovi <mfv@debian.org>
 Build-Depends:
  cmake (>= 3.5),
  debhelper (>= 11~),
  freerdp2-dev (>= 2.0.0~),
- libayatana-appindicator3-dev | libappindicator3-dev,
+ libappindicator3-dev | libayatana-appindicator3-dev,
  libavahi-ui-gtk3-dev (>= 0.6.0),
  libgcrypt-dev | libgcrypt20-dev,
  libgnutls28-dev,
@@ -23,8 +24,9 @@
  libtelepathy-glib-dev,
  libvncserver-dev,
  libvte-2.91-dev,
- libxkbfile-dev
-Standards-Version: 4.1.3
+ libxkbfile-dev,
+ intltool
+Standards-Version: 4.1.4
 Homepage: http://www.remmina.org/
 Vcs-Git: https://salsa.debian.org/debian-remote-team/remmina.git
 Vcs-Browser: https://salsa.debian.org/debian-remote-team/remmina

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,12 @@
 
 override_dh_install:
 	dh_install
+	cd remmina/po; intltool-update --pot --verbose -g remmina
 	[ -d debian/remmina-common ] && \
 		find $(CURDIR)/debian/remmina-common -name "*remmina.desktop" -delete && \
 		find $(CURDIR)/debian/remmina-common -name "*remmina.1" -delete && \
 		find $(CURDIR)/debian/remmina-common -type d -empty -delete || true
+
+override_dh_clean:
+	-rm remmina/po/remmina.pot
+	dh_clean

=== debian/watch ===
version=4
opts="dversionmangle=s%\+dfsg\d*$%%, \
filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%remmina_$1.tar.gz%" \
https://github.com/FreeRDP/Remmina/releases /FreeRDP/Remmina/archive/v(.+)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz) debian sh debian/repack.stub

## remmina 1.2.31.2+dfsg

=== CMakeLists.txt ===
# Remmina - The GTK+ Remote Desktop Client
#
# Copyright (C) 2011 Marc-Andre Moreau
# Copyright (C) 2014-2015 Antenore Gatta, Fabio Castelli, Giovanni Panozzo
# Copyright (C) 2016-2018 Antenore Gatta, Giovanni Panozzo
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor,
# Boston, MA  02110-1301, USA.
#
# In addition, as a special exception, the copyright holders give
# permission to link the code of portions of this program with the
# OpenSSL library under certain conditions as described in each
# individual source file, and distribute linked combinations
# including the two.
# You must obey the GNU General Public License in all respects
# for all of the code used other than OpenSSL. If you modify
# file(s) with this exception, you may extend this exception to your
# version of the file(s), but you are not obligated to do so. If you
# do not wish to do so, delete this exception statement from your
# version. If you delete this exception statement from all source
# files in the program, then also delete it here.


cmake_minimum_required(VERSION 2.8.2)

set(CMAKE_COLOR_MAKEFILE ON)

project(Remmina C)

include(CheckIncludeFiles)
include(CheckLibraryExists)
include(FindPkgConfig)
include(CheckCCompilerFlag)
include(GNUInstallDirs)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/)

include(FindOptionalPackage)
include(ConfigOptions)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release")
endif()

if(NOT BUILD_SHARED_LIBS)
    set(BUILD_SHARED_LIBS ON)
endif()

if(CMAKE_COMPILER_IS_GNUCC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
    if(WITH_SSE2)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse2")
    endif()
    check_c_compiler_flag(-Wno-unused-function Wno-unused-function)
    if(Wno-unused-function)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-function")
    endif()
endif()

check_include_files(sys/socket.h HAVE_SYS_SOCKET_H)
check_include_files(arpa/inet.h HAVE_ARPA_INET_H)
check_include_files(netinet/in.h HAVE_NETINET_IN_H)
check_include_files(netinet/tcp.h HAVE_NETINET_TCP_H)
check_include_files(termios.h HAVE_TERMIOS_H)
check_include_files(netdb.h HAVE_NETDB_H)
check_include_files(fcntl.h HAVE_FCNTL_H)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(sys/un.h HAVE_SYS_UN_H)
check_include_files(errno.h HAVE_ERRNO_H)

include_directories(.)
include_directories(src/include)

# FreeBSD

if(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
    set(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "-rdynamic")
    include_directories(/usr/local/include /usr/include)
    link_directories(/usr/local/lib /usr/lib)
    set(CMAKE_REQUIRED_INCLUDES /usr/local/include)
    set(CMAKE_SHARED_LIBRARY_PREFIX ${CMAKE_SHARED_LIBRARY_PREFIX} /usr/local/lib)
endif()

# Versioning
set(WITH_LIBRARY_VERSIONING "ON")
set(REMMINA_VERSION_MAJOR "1")
set(REMMINA_VERSION_MINOR "2")
set(REMMINA_VERSION_REVISION "31")
set(REMMINA_VERSION_SUFFIX "2")
#set(REMMINA_VERSION "${REMMINA_VERSION_MAJOR}.${REMMINA_VERSION_MINOR}.${REMMINA_VERSION_REVISION}")
set(REMMINA_VERSION "${REMMINA_VERSION_MAJOR}.${REMMINA_VERSION_MINOR}.${REMMINA_VERSION_REVISION}.${REMMINA_VERSION_SUFFIX}")

message(STATUS "Remmina version: ${REMMINA_VERSION}")

include(GetGitRevisionDescription)
git_get_exact_tag(REMMINA_GIT_REVISION --tags --always)
if(${REMMINA_GIT_REVISION} STREQUAL "n/a")
    git_rev_parse(REMMINA_GIT_REVISION --short)
endif()

message(STATUS "Git Revision: ${REMMINA_GIT_REVISION}")

# REMMINA_APP_ID should follow Gnome Application ID rules
set(REMMINA_APP_ID "org.remmina.Remmina")

if(NOT REMMINA_DATADIR)
    set(REMMINA_DATADIR "${CMAKE_INSTALL_FULL_DATADIR}")
    if(NOT REMMINA_RUNTIME_DATADIR)
        set(REMMINA_RUNTIME_DATADIR "${REMMINA_DATADIR}")
    endif()
endif()
if(NOT REMMINA_TERM_CS_DIR)
    set(REMMINA_TERM_CS_DIR "${REMMINA_DATADIR}/remmina/term_colors")
endif()
if(NOT REMMINA_LOCALEDIR)
    set(REMMINA_LOCALEDIR "${CMAKE_INSTALL_FULL_LOCALEDIR}")
    if(NOT REMMINA_RUNTIME_LOCALEDIR)
        set(REMMINA_RUNTIME_LOCALEDIR "${REMMINA_LOCALEDIR}")
    endif()
endif()
if(NOT REMMINA_PLUGINDIR)
    set(REMMINA_PLUGINDIR "${CMAKE_INSTALL_FULL_LIBDIR}/remmina/plugins")
    if(NOT REMMINA_RUNTIME_PLUGINDIR)
        set(REMMINA_RUNTIME_PLUGINDIR "${REMMINA_PLUGINDIR}")
    endif()
endif()
if(NOT REMMINA_UIDIR)
    set(REMMINA_UIDIR "${REMMINA_DATADIR}/remmina/ui")
    if(NOT REMMINA_RUNTIME_UIDIR)
        set(REMMINA_RUNTIME_UIDIR "${REMMINA_UIDIR}")
    endif()
endif()
if(NOT REMMINA_THEMEDIR)
    set(REMMINA_THEMEDIR "${REMMINA_DATADIR}/remmina/theme")
    if(NOT REMMINA_RUNTIME_THEMEDIR)
        set(REMMINA_RUNTIME_THEMEDIR "${REMMINA_THEMEDIR}")
    endif()
endif()
if(NOT REMMINA_EXTERNAL_TOOLS_DIR)
    set(REMMINA_EXTERNAL_TOOLS_DIR "${REMMINA_DATADIR}/remmina/external_tools")
    if(NOT REMMINA_RUNTIME_EXTERNAL_TOOLS_DIR)
        set(REMMINA_RUNTIME_EXTERNAL_TOOLS_DIR "${REMMINA_EXTERNAL_TOOLS_DIR}")
    endif()
endif()

# Snap package generation support
if(DEFINED ENV{SNAPCRAFT_PROJECT_NAME})
    add_subdirectory(snap)
else()
    find_program(SNAPCRAFT "snapcraft")
    if(SNAPCRAFT)
        add_subdirectory(snap)
    endif()
endif()

option(SNAP_BUILD_ONLY "SNAP_BUILD_ONLY" OFF)
if(SNAP_BUILD_ONLY)
    if(NOT SNAPCRAFT)
        message(FATAL_ERROR "snapcraft not found, impossible to create only snap target")
    endif()
    return()
endif()

if(SNAP_BUILD)
    add_definitions(-DSNAP_BUILD)
endif()

# Uninstall support
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)
add_custom_target(uninstall
    "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

find_required_package(GTK)

set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
find_package(Threads REQUIRED)
if(NOT CMAKE_USE_PTHREADS_INIT)
    message(FATAL_ERROR "pthreads thread library not found")
endif()

# Add GCC sanitizer options, must be done after pthreads detection
# see remmina issue #1276
if(CMAKE_COMPILER_IS_GNUCC AND WITH_GCC_SANITIZE_ADDRESS)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address")
endif()

# LLVM coverage flags - https://clang.llvm.org/docs/SourceBasedCodeCoverage.html
if("${CMAKE_C_COMPILER_ID}" MATCHES "Clang" AND WITH_CLANG_COVERAGE)
    message(STATUS "Enabling coverage.")
    add_definitions(-DWITH_CLANG_COVERAGE)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fprofile-instr-generate -fcoverage-mapping")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fprofile-instr-generate")
elseif("${CMAKE_C_COMPILER_ID}" MATCHES "GNU" AND WITH_GCC_PROFILING)
    message(STATUS "Enabling profiling.")
    add_definitions(-DWITH_GCC_PROFILING)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pg")
endif()

find_suggested_package(GCRYPT)
find_suggested_package(AVAHI)
find_package(OpenSSL)

if(WITH_TRACE_CALLS)
    message(STATUS "Enabling trace calls.")
    add_definitions(-DWITH_TRACE_CALLS)
endif()

option(WITH_MANPAGES "Build with MANPAGES" ON)
if(WITH_MANPAGES)
    message(STATUS "Enabling man pages.")
    add_definitions(-DWITH_MANPAGES)
else()
    message(STATUS "Man pages disabled")
endif()

if(GCRYPT_FOUND)
    add_definitions(-DHAVE_LIBGCRYPT)
endif()

if(AVAHI_FOUND)
    add_definitions(-DHAVE_LIBAVAHI_UI)
    add_definitions(-DHAVE_LIBAVAHI_CLIENT)
endif()

if(GTK_FOUND)
    add_subdirectory(src)
    add_subdirectory(data)
    add_subdirectory(plugins)
    add_subdirectory(plugins/secret)
endif()

if(WITH_TRANSLATIONS)
        add_subdirectory(po)
endif()


configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
    ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
